/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "operate/operate.pmh"

using namespace fe;
void OperatorSurfaceCommon::bind(sp<SignalerI> a_spSignalerI,
									sp<Layout> a_spLayout)
{
	OperateCommon::bind(a_spSignalerI,a_spLayout);

	m_aStartFrame.initialize(a_spLayout->scope(),
			"StartFrame");
	m_aEndFrame.initialize(a_spLayout->scope(),
			"EndFrame");
	m_aFrame.initialize(a_spLayout->scope(),
			"Frame");
	m_aTime.initialize(a_spLayout->scope(),
			"Time");
	m_aSurfaceOutput.initialize(a_spLayout->scope(),
			"SurfaceOutput");
	m_aDrawOutput.initialize(a_spLayout->scope(),
			"DrawI");
	m_aDrawGuide.initialize(a_spLayout->scope(),
			"DrawGuide");
	m_aDrawBrush.initialize(a_spLayout->scope(),
			"DrawBrush");
	m_aDrawBrushOverlay.initialize(a_spLayout->scope(),
			"DrawBrushOverlay");
	m_aCameraTransform.initialize(a_spLayout->scope(),
			"CameraTransform");
	m_aRayOrigin.initialize(a_spLayout->scope(),
			"RayOrigin");
	m_aRayDirection.initialize(a_spLayout->scope(),
			"RayDirection");
}

String OperatorSurfaceCommon::generateSignature(
	sp<SurfaceAccessibleI>& a_rspAccessibleI)
{
	sp<SurfaceAccessorI> spPoints;
	if(!access(spPoints,a_rspAccessibleI,e_point,e_generic))
	{
		return "";
	}

	sp<SurfaceAccessorI> spVertices;
	if(!access(spVertices,a_rspAccessibleI,e_primitive,e_vertices))
	{
		return "";
	}

	const I32 pointCount=spPoints->count();
	const I32 primitiveCount=spVertices->count();

	String signature;
	signature.sPrintf("%d:%d",pointCount,primitiveCount);

	return signature;
}
